/*
 * Setup pointers to hardware dependand routines.
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1996 by Ralf Baechle
 */
#include <asm/ptrace.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/timex.h>
#include <linux/mc146818rtc.h> 
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/vector.h>
#include <asm/mipsregs.h>

extern struct feature decstation_feature;
extern asmlinkage void decstation_handle_int(void);
extern void decstation_test(void);
 

static void
dec_irq_setup(void)
{
#ifdef 0
    volatile unsigned int *ioasic_sirm = (unsigned int *)SIRM;
#endif
    printk("In dec_irq_setup\n");
    set_except_vector(0, decstation_handle_int);

    /*
     * Just to be shure, turn everything off ... HK
     */
    CMOS_WRITE(CMOS_READ(RTC_REG_B) & ~RTC_PIE & ~RTC_AIE & ~RTC_UIE, RTC_REG_B
);
#ifdef 0
    *ioasic_sirm = 0;
#endif
    /*
     * Here wo go, enable periodic rtc interrupts and unmask clock interrupts.
     * This works only on kmin and 3maxplus, on maxines SIRM is not needed and
     * interrupt is IRQ1, IRQ3 on 3min and IRQ1 on 3max. Change int_handler.S
     * a ccordingly. Frequency is 64 Hz.
     */

    CMOS_WRITE(RTC_REF_CLCK_32KHZ | 0xa, RTC_REG_A);
    CMOS_WRITE(CMOS_READ(RTC_REG_B) | RTC_PIE, RTC_REG_B);
#ifdef 0
    *ioasic_sirm = 0x20;
#endif
    set_cp0_status(ST0_IM, IE_IRQ1);
#ifdef 0
    set_cp0_status(ST0_IM, IE_IRQ3);
    set_cp0_status(ST0_IM, IE_IRQ3 | IE_IRQ4);
#endif
    printk("Done dec_irq_setup\n");
}

void (*board_time_init)(struct irqaction *irq);

static void dec_time_init(struct irqaction *irq)
{
	printk("Please write the time init code for the DECStation!\n");
}

void
decstation_setup(void)
{
	irq_setup = dec_irq_setup;
	board_time_init = dec_time_init;
	/* FIXME: Setup fd_cacheflush */
	feature = &decstation_feature;		/* FIXME: Will go away */
}
